JSDoc 1.9.9.2
=============

- Fixed disappearing argument list for package-style class constructors

JSDoc 1.9.9.1
=============

- Fixed bug in template dir designation that caused JSDoc to crash if
  run from an absolute path

JSDoc 1.9.9
===========

- Added a commandline parameter for supplying a template directory
    
- Adding sorting of class names on overview-summary-$filename.js
  (sf.net bug #1416564)
    
- Fix for broken anchors from the overview-summary-$filename page to static 
  methods (SF.net bug #1416543)

JSDoc 1.9.8.1
=============

- Don't touch the file source (src) when processing the file overview data

- Pick up functions as constructors of the @class tag is used

JSDoc 1.9.8
===========

- Allow the @base tag to accept the form: @base ClassName URL (RFE 1114510)

- Be more lenient with @param and @return types (RFE 1104728)

- Corrected CSS error, changed "pts" to "pt"

JSDoc 1.9.7
===========

- Added "--no-lexical-privates" option to ignore locally-defined values 
  from within constructors

- Fixed linking to static fields/methods

JSDoc 1.9.6.2
=============

- Set correct permissions on files in packaging script

- Fixed compile error on some versions of perl

- Create distinct anchors for static methods and fields in HTML so that
  if there is a static and instance method of the same name, the links work
  correctly

JSDoc 1.9.6.1
=============

- Updated unit tests for clearing of function contents

- Removed collapsing of string literals; this was originally added for version
  1.9.5.1 to avoid segfaults, but the decision has been made that it is up
  to the user to use a version of perl that doesn't segfault instead of 
  trying to work around it in perl code.

- Added (experimental) @exec tag for initialization blocks that should be 'run'

JSDoc 1.9.6
===========

- Fix for incorrect return type and parameter types for static method 
  listing in file overview

- Clear out unused nested functions with the preprocessor to avoid problems

JSDoc 1.9.5.8
=============

- Yet another fix for __defineGetter__ and __defineSetter__

JSDoc 1.9.5.7
=============

- Fixed bug in syntax highlighting for single-line inline comments

- Fixed bug in preprocessing of __defineGetter__ and __defineSetter__

JSDoc 1.9.5.6
=============

- Fixed incorrect listing of private classes when --private not enabled

JSDoc 1.9.5.4
=============

- Corrected bug with function assignment inside constructor

JSDoc 1.9.5.3
=============

- Added ability to specify different file extensions on commandline

JSDoc 1.9.5.2
=============

- Fixed formatted text munging for @class description

- Added support for @package tag to be used with XMI export

JSDoc 1.9.5.1
=============

- Added collapsing of string literals during preprocessing

JSDoc 1.9.5
===========

- Added listing of global (static) methods to file overview summary, code
  submitted by Jeremy Gillick

- Allow a global variable to be defined as a class from an anonymous
  function declaration

JSDoc 1.9.4.2.1
===============

- Further fix for typed parameter names starting with a dollar sign

JSDoc 1.9.4.2
=============

- Added ability to handle parameter names starting with a dollar sign

JSDoc 1.9.4.1
=============

- Only use the first sentence for file and class summary on the 
  overview pages

- Add a non-breaking space in the overview summary tables when there is no
  appropriate value to display

JSDoc 1.9.4
===========

- If there are multiple source files documented, the index page defaults
  to the overview summary for the main frame

- Made JSDoc site link open in parent frame

- Added overview and file summary tables (similar to package overview table
  in JavaDoc)

JSDoc 1.9.3.1
=============

- Fixed duplicate class-tree output

JSDoc 1.9.3
===========

- Added alpha release of XML and XMI output formats

- Upgrade a function to a class if the @base tag is used

- Fixed issue with sub-package nested classes requiring the @addon tag

- Added the implicit "Object" class to the inheritance tree, as well as 
  other classes that are referenced but not defined

JSDoc 1.9.2.1
=============

- Added @addon tag, which is used when adding static methods to core classes
  or classes not defined within the files being documented

- Fix for the base class of nested classes not being properly set

- Fix for infinite recursion when all classes are private


JSDoc 1.9.2
===========

- Removed unecessary table from overview-summary.tmpl

- Added the @ignore tag to allow total hiding of functions 

- Fix for incorrect marking of methods as void when the return value is
  enclosed in parentheses

- Fix so that methods with a @return tag but without a return statement
  are not marked as void

- Fixed issue with not all files being listed in the file listing


JSDoc 1.9.1.3
=============

- Fixed issue with backslashes in path

- Fixed issue with <pre> tags and JavaScript code within fileoverview sections

- Made documented versions of a method take precedence over a 
  non-documented version

- Added support for prototype assignment without parentheses

- Added new @return label {type typeLink} Description... syntax

JSDoc 1.9.1.2
=============

- Further improvements to mark_void_method

- Improved handling of dynamically-bound methods within functions

- Improved handling of erroneous documenting of 'this'

- Fixed quoting on error message

- Added a few new unit tests for testing general behaviour

JSDoc 1.9.1.1
=============

- Fix for embarrassing bug in mark_void_method

JSDoc 1.9.1
===========

- Fix for the incorrect void marking of methods that return a string literal

- Fix to stop dynamic prototyping from adding non-dynamic classes

- Added ability to add a link to parameter-type data, as follows:
    @param {TypeName http://my.link.com/} myParam Description of parameter

JSDoc 1.9
=========

- Added support for a Constant Values page like in Javadoc

- Added support for private classes (by marking the constructor with
  the @private attribute)

- Added a "File" page with links to it in the navbar. The "File" page includes
  the file overview if one has been supplied, as well as the source view
  (unless jsdoc has been invoked with the --no-sources flag)

- Added a --no-sources commandline option to not show the sourcecode for
  the JavaScript files 

- Added --package-naming commandline option, which specifies that the path 
  leading to each source file will be preserved. This allows for the same 
  filename to be used in different directories. Using the same class name
  in different packages is _not_ supported (yet)

- Added JSDoc link and creation time in the footer of each page

- Added support for @member tag to explicitly mark a method as a member of
  a class

JSDoc 1.8.4
===========

- Added step in prepocessing to attempt to add missing @constructor tags where
  the 'new' operator is used in combination with a function name elsewhere
  in the source.

- Only the first @extends marking (or assignment of an instance to a sub-
  class's prototype) will be used in determining the base class of a class.

- Updated test.js to show off more features of JSDoc, as well as a general 
  clean-up.
    
- Changed the parser to consider a method to be a class declaration if its
  documentation contains a @class tag (in addition to the @constructor tag)

JSDoc 1.8.3.1
=============

- Some general code cleanup and refactoring. 

- Properly fixed marking of void/non-void methods, and at the same time
  re-introduced recursive regexes (this time non-dynamic, as dynamic seem
  to be much too unstable)

JSDoc 1.8.3
===========

- Changed the handling for __defineGetter__ and __defineSetter__
  to define a property instead of a method in the documentation

- Fixed bug in parse_jsdoc_comment that didn't allow for email addresses
  to be entered verbatim (instead, the domain of the address was parsed
  as a tag)

- Re-did the @fileoverview parsing, now other tags and inner {@link...} 
  tags are included. Additionally, if only one file is processed and there
  is no project overview file included, the file's overview (if it exists)
  is used as the project overview. Thanks to Robert Flaherty for input
  and bug reports on this issue.

JSDoc 1.8.2.1
=============

- Got rid of extra '*' with @fileoverview

JSDoc 1.8.2
=============

- Fixed bug where other @tags were included as part of the @fileoverview

- Added support for @version in method documentation

- Partial fix for incorrect marking of void methods

- Made field and return @type handling more robust and flexible

JSDoc 1.8.1
===========

- Added @extends as a synonym for @base

- Fixed doubled-up <UL> tags in hierarchy tree code (thanks to Robert Flaherty)

- Fixed bug where a class's base class would not get recorded if
  there was a forward assignment of a static value to the class 
  (thanks to Robert Flaherty)
  

JSDoc 1.8
=========

- Remove the GLOBALS class if it is empty

- Fixed case-sensitive sort in index

- Added support for comments with long blocks of '*'s in the opening and 
  closing of the doc string

- Added sourcecode view

- Fixed bug where named anonymous functions were not recognized as methods
  when assigned to prototypes

- Allow for singletons to be declared with var

- Allow for binding static properties to classes before they are defined

- Added @overviewfile attribute for class documentation, inlines html or
  textfiles into the documentation

- Added beginnings of unit testing

- Don't add 'constructor' as an instance or class property

- Added an @overviewfile tag which can be put in an independent 
  jsdoc-comment block at the top of each file. This results in a project
  overview page for each file with an overview, similar to JavaDoc's 
  package pages.

- Added support for Mozilla's __defineGetter__ and __defineSetter__

- Return type for methods is now Object, and is displayed instead of the
  'function' declaration. The 'void' type is shown if no return can be
  found in the function and no other type is defined. The defaulting to
  Object also goes for fields, and is shown instead of the 'var' declaration

- Allow usage of the {@link url label} construct for the @type tag


JSDoc 1.7.2.1
=============

- Fixed segfault problem in huge constructors with deconstruct_constructor
  selection regex


JSDoc 1.7.2
===========

- Added a @class tag to constructors, for providing class-specific information

- Added handling for Singleton classes

- Added handler for @base tag to denote inheritance

JSDoc 1.7.1.4
=============

- Fixed bug introduced by refactoring of &format_link

JSDoc 1.7.1.3
=============

- Added workaround in &format_link for apparent bug in some builds of
  perl 5.8.0

- Fixed bug in handling of --recursive (was always recursive)

JSDoc 1.7.1.2
=============

- Fixed problems with new preprocessor when confronted with nested classes

JSDoc 1.7.1.1
=============

- Fixed bug where {@link}s inside of @params weren't processed

JSDoc 1.7.1
===========

- Added --quiet switch and message to signify ending of successful execution

- Fixed problem with perl segfaulting on big class prototype block definitions

- Fixed incorrectly formatted {@link}s nested in other @attributes

- Added preprocessor for handling private methods to replace bulky
  and buggy evaluate_constructor method

JSDoc 1.7
=========

- Added usage of strict and warnings in JSDoc.pm

- Added ability to set type information for method parameters
  (e.g. /** @param {String} userName The name of the current user */ )

- Added support for class prototype initialization blocks (finally!)

JSDoc 1.6.3.1
=============

- Fixed bug where static fields initialized to 0 are not picked up

JSDoc 1.6.3
===========

- Removed the constraint that a nested class constructor must be marked
  with the @constructor attribute

- Allow @constructor attribute to mark nested class constructors which would
  otherwise be considered static methods

- Allow newlines as well as semi-colon for line-endings

- Allow a leading '$' for field names


JSDoc 1.6.2.1
=============

- Fixed splicing error for nested classes, thanks again to jdber 


JSDoc 1.6.2
===========

- Carry over overridden method description attributes even if there is
  no text description to carry over

- Improved HTML in main.tmpl 

- Fixed infinite loop and recognition for when static inner class construct is 
  used (thanks to jdber for the patch)

- Added a Nested Class Summary section to the output documentation to display
  inner classes

JSDoc 1.6.1.1
=============

- Fixed bug in carrying over description of overridden methods

JSDoc 1.6.1
===========

- Improved the format_link function in jsdoc.pl so that {@links} will
  not be made to non-existent resources, and parentheses are not placed
  after a field name (as opposed to a method name)

- Carry over method documentation for overridden methods if no new 
  documentation has been supplied for the method. This is in following with
  javadoc functionality

- Fixed /* functionality(whatever) bug

- Fixed remaining problems with comments inside of parameter lists

JSDoc 1.6
=========

- Big cleanup in jsdoc.pl in terms of writing templates to file

- Fixed bug where multi-line @params don't work

- Added filename-scoped frame, as well as the name of the filename for
  each class

- Improved the linking implementation for @link and @see to do a better job
  in terms of not building broken links

JSDoc 1.5.2
===========

- Changed the name '[default context]' for non-class functions to be
  GLOBALS, also made this name configurable with command-line parameters

- Made jsdoc easily runnable from anywhere on the filesystem, without 
  requiring installing JSDoc.pm in the @INC

JSDoc 1.5.1
===========

- Added support for @requires in methods

- Generic '@' attributes now work for constructors, such as @see and @throws.
  Also added support for @return and @returns for constructors

- Fixed the @link construct to allow custom labels

- Added standard support for @author in methods as well as classes
  (Thanks for Rainer Eschen for bringing me to my senses)

- Fixed spacing for @author attributes


JSDoc 1.5
===========

- Fixed bug that would break HTML links within documentation

- Fixed bug in path to logo in IMG tags

- Added support for type information for both methods and fields

- Added suppport for @private in instance fields

- Fixed bug where private methods would show up in the inherited methods list
  in subclasses

- Private class methods are now also supported

- Method parameters details are displayed in the same order as the parameter 
  list for a method

- Moved more info into the 'vars' member of methods, and away from the parser

- Added @final (with synonym @const) for class and instance properties

- Fix in parser where string literals bound to classes in a constructor were
  not caught by the parser



JSDoc 1.4
=========

- Added @attributes: @author, @deprecated, @see, @version, @requires, @throws

- Updated pod (removed documentation for non-existant parse_jsdoc_source, 
added a small example)

- Added function to reset the parser (reset_parser)

- Fixed bug where the same property could be bound to a class's prototype
more than once

- Fixed bug where embedded // comments would break the parser

- Added ability to set project name, page footer, logo and project summary
(thanks to Jeff Conrad for code and suggestions)

- Added overview summary (thanks to Jeff Conrad for code)

- Split up loading/parsing of sources file to prevent crashes that were caused
by overloading the regex engine

- Added overview-tree (thanks to Jeff Conrad for the code contribution)

- Fixed bug where some assignments of methods to instances in a constructor
would get lost

- Fix in doc-parsing where a line with only a star and a newline would get
passed over

- Added ability to 'hide' methods with @private


JSDoc 1.3
=========

- When a function is marked with @constructor, it will always be dealt
with as a class

- Improved doc regex

- Added recursive directory handling
